package org.commonjava.tensor.ispn.data.store;

import javax.enterprise.context.ApplicationScoped;
import javax.inject.Inject;

import org.commonjava.tensor.data.store.IndexStore;
import org.commonjava.tensor.data.store.IndexStoreFactory;
import org.infinispan.manager.CacheContainer;

import com.google.gson.reflect.TypeToken;

@ApplicationScoped
public class IspnIndexStoreFactory
    implements IndexStoreFactory
{

    @Inject
    private CacheContainer container;

    @Override
    public <K, V> IndexStore<K, V> getStore( final String name, final Class<K> keyType, final Class<V> valueType )
    {
        return new CacheIndexStore<K, V>( name, container );
    }

    @Override
    public <K, V> IndexStore<K, V> getStore( final String name, final Class<K> keyType, final TypeToken<V> valueType )
    {
        return new CacheIndexStore<K, V>( name, container );
    }

}
