package org.commonjava.tensor.ispn.io.json;

import java.util.Map;

import org.commonjava.util.logging.Logger;
import org.infinispan.configuration.cache.ConfigurationBuilder;
import org.infinispan.configuration.global.GlobalConfigurationBuilder;
import org.infinispan.configuration.global.SerializationConfigurationBuilder;

//@javax.enterprise.context.ApplicationScoped
public class JsonTensorCacheConfigurator
//    implements TensorCacheConfigurator // block this to see if performance improves.
{

    //    @Override
    public void configure( final GlobalConfigurationBuilder globalConfig, final ConfigurationBuilder defaultConfig,
                           final Map<String, ConfigurationBuilder> namedConfigs )
    {
        new Logger( getClass() ).info( "Running tensor cache configurator: %s", getClass().getName() );
        final SerializationConfigurationBuilder ser = globalConfig.serialization();

        ser.addAdvancedExternalizer( 2000, new EGraphFactsExt() );
        ser.addAdvancedExternalizer( 2001, new EProjectGraphExt() );
        ser.addAdvancedExternalizer( 2002, new EProjectKeyExt() );
        ser.addAdvancedExternalizer( 2003, new EProjectRelsExt() );
        ser.addAdvancedExternalizer( 2004, new EProjectWebExt() );
        ser.addAdvancedExternalizer( 2005, new ProjectRefExt() );
        ser.addAdvancedExternalizer( 2006, new ProjectRelationshipExt() );
        ser.addAdvancedExternalizer( 2007, new ProjectVersionRefExt() );
        ser.addAdvancedExternalizer( 2008, new ParentRelationshipExt() );
        ser.addAdvancedExternalizer( 2009, new DependencyRelationshipExt() );
        ser.addAdvancedExternalizer( 2010, new PluginRelationshipExt() );
        ser.addAdvancedExternalizer( 2011, new ExtensionRelationshipExt() );
        ser.addAdvancedExternalizer( 2012, new PluginDependencyRelationshipExt() );
        ser.addAdvancedExternalizer( 2013, new ArtifactRefExt() );
    }

}
